// The interference table is a list of cellsets. 
//
// The interference set for cell X is the set of cells that can't have the same 
// value as X.
//
// Again, you're encouraged to reach in and use this directly: it's just a
// jagged array of arrays!

#ifndef INTERFERENCE_H
#define INTERFERENCE_H

#include "cellset.h"
#include "shared.h"

typedef struct {
    cellset_t rows[N_CELLS];
} interference_t;

extern interference_t interference;

// Initialize the global interference table.
void interference_init();

#endif
