// A constraint propagation operation generates a propagation result.
//
// Such a result is a list of cells that were touched and a "viable" flag.
//
// If "viable" is false, then at least one cell became impossible to fill
// during the propagation operation. (That is, the propagate operation found
// a contradiction.)

#ifndef PUZZLE_PROPAGATE_RESULT_H
#define PUZZLE_PROPAGATE_RESULT_H

#include <stdbool.h>
#include "cellset.h"

typedef struct {
    bool viable;
    cellset_t cells;
} puzzle_propagate_result_t;
#endif
